﻿----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design."---------------
----------------------------------------------------------------------------

rollOver = {};
rollOver.buttonDown = false;
rollOver.currentForce = 0;
rollOver.lastDirection = 0;
rollOver.renderText = Utils.getNoNil(g_i18n:getText("rollNoNeedText"),"rollOver missing text");
function rollOver.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Washable, specializations)
		and SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

function rollOver.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", rollOver);
	SpecializationUtil.registerEventListener(vehicleType, "onLeave", rollOver);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", rollOver);
end;

function rollOver:onLoad(savegame)
	self.rollOver = {};
	--self.rollOver.actionEvents = {};	
	--self.rollOver.renderHelp = false;
	local vehicleWidth = Utils.getNoNil(self.sizeWidth, 3);
	self.rollOver.leftOffset = -((vehicleWidth/2)+0.2);
	self.rollOver.rightOffset = (vehicleWidth/2)+0.2;
	self.rollOver.heightOffset = vehicleWidth+0.2;
	local _,_,cz = getCenterOfMass(self.rootNode);
	self.rollOver.lengthOffset = cz;
end;

--[[function rollOver:onRegisterActionEvents(isActiveForInput)
    if self.isClient then
			local spec = self.rollOver;
			self:clearActionEventsTable(spec.actionEvents);
			spec.actionEventIds = {};			
		if self:getIsActiveForInput(true, true) then
            local _, actionEventId = self:addActionEvent(spec.actionEvents, "ROLLOVERKEY1", self, rollOver.onInputAction, false, true, false, true, nil);
            g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_VERY_LOW);
            g_inputBinding:setActionEventTextVisibility(actionEventId, true);
			table.insert(spec.actionEventIds, actionEventId);			
			if actionEventId == "" then
				local _, actionEventId = self:addActionEvent(spec.actionEvents, "ROLLOVERKEY1", self, rollOver.onInputAction, false, true, false, true, nil);
				g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_VERY_LOW);
				g_inputBinding:setActionEventTextVisibility(actionEventId, true);
				table.insert(spec.actionEventIds, actionEventId);
			end;
        end;
    end;
end;

function rollOver.onInputAction(self, actionName, inputValue, callbackState, isAnalog)
end;]]

function rollOver:onUpdate(dt)
	if self.spec_enterable ~= nil then
		if self.spec_enterable.isEntered then
			if Input.isKeyPressed(Input.KEY_f9) then --if actionName == "ROLLOVERKEY1" then				
				local node = self.components[1].node;
				local baseForce = (10*self:getTotalMass(true));
				local force = baseForce;	
				local dirX,dirY,dirZ = localDirectionToWorld(node,0,1,0);
				local vx,vy,vz = getAngularVelocity(node);
				local vL = 2.0; --velocity Limit
				local attachments = 0;
				if self.spec_attacherJoints ~= nil then
					attachments = Utils.getNoNil(#self.spec_attacherJoints.attachedImplements,attachments);
				end;
				if (vx < vL) and (vx > -vL) and (vy < vL) and (vy > -vL) and (vz < vL) and (vz > -vL) then
					if Input.isKeyPressed(Input.KEY_lshift) then					
						if force > 0 and rollOver.currentForce < force then 
							rollOver.currentForce = rollOver.currentForce+(force*(dt*0.001));
							force = rollOver.currentForce;
						end;						
						rollOver.lastDirection = 0;
						addForce(node,dirX*force,dirY*force,dirZ*force,self.rollOver.leftOffset,self.rollOver.heightOffset,self.rollOver.lengthOffset,true);
						if attachments > 0 then
							for _,attachment in pairs(self.spec_attacherJoints.attachedImplements) do
								attachment = attachment.object;
								if attachment.spec_wheels ~= nil and #attachment.spec_wheels.wheels > 0 then
									local aForce = (7*attachment:getTotalMass(true)/baseForce);
									aForce = force*aForce;
									local nodeB = attachment.components[1].node;
									local dirXB,dirYB,dirZB = localDirectionToWorld(nodeB,0,1,0);
									addForce(nodeB,dirXB*aForce,dirYB*aForce,dirZB*aForce,attachment.rollOver.leftOffset,attachment.rollOver.heightOffset,attachment.rollOver.lengthOffset,true);
								end;
							end;
						end;
					elseif Input.isKeyPressed(Input.KEY_rshift) then						
						if force > 0 and rollOver.currentForce < force then 
							rollOver.currentForce = rollOver.currentForce+(force*(dt*0.001));
							force = rollOver.currentForce;
						end;
						rollOver.lastDirection = 0;
						addForce(node,dirX*force,dirY*force,dirZ*force,self.rollOver.rightOffset,self.rollOver.heightOffset,self.rollOver.lengthOffset,true);
						if attachments > 0 then
							for _,attachment in pairs(self.spec_attacherJoints.attachedImplements) do
								attachment = attachment.object;			
								if attachment.spec_wheels ~= nil and #attachment.spec_wheels.wheels > 0 then
									local aForce = (7*attachment:getTotalMass(true)/baseForce);
									aForce = force*aForce;
									local nodeB = attachment.components[1].node;
									local dirXB,dirYB,dirZB = localDirectionToWorld(nodeB,0,1,0);
									addForce(nodeB,dirXB*aForce,dirYB*aForce,dirZB*aForce,attachment.rollOver.rightOffset,attachment.rollOver.heightOffset,attachment.rollOver.lengthOffset,true);
								end;
							end;
						end;
					else					
						local isAlreadyLevel = false;
						local direction = 1;
						local preventWobble = false;
						--[[if self.spec_crawlers ~= nil and self.spec_crawlers.crawlers ~= nil then
							local crawlerA = self.spec_crawlers.crawlers[1];
							local i = Utils.getNoNil(crawlerA.oppositeWheelIndex,2);
							local crawlerB = self.spec_crawlers.crawlers[i];
							if crawlerB == nil then return; end;
							local nodeA = crawlerA.loadedCrawler; if nodeA == nil then nodeA = crawlerA.node; end;
							local nodeB = crawlerB.loadedCrawler; if nodeA == nil then nodeA = crawlerB.node; end;
							local xA,yA,zA = getWorldTranslation(nodeA);
							local xB,yB,zB = getWorldTranslation(nodeB);
							local gYA = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, xA,yA,zA);
							local gYB = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, xB,yB,zB);
							local difA = yA-gYA; if difA < 0.025 then difA = 0; end;
							local difB = yB-gYB; if difB < 0.025 then difB = 0; end;
							if difA > difB then
								direction = -1;
							elseif difA <=0 and difB <=0 then
								force = 0;
							end;
						else]]if self.spec_wheels ~= nil and self.spec_wheels.wheels ~= nil then
							local wCount = 0;
							for w=1, #self.spec_wheels.wheels do
								local wheel = self.spec_wheels.wheels[w];
								if wheel.contact ~= Wheels.WHEEL_NO_CONTACT then
									wCount = wCount+1;
								end;
							end;
							if wCount == #self.spec_wheels.wheels then isAlreadyLevel = true; end;
							if not isAlreadyLevel then
								local wheelA = self.spec_wheels.wheels[1];
								local i = Utils.getNoNil(wheelA.oppositeWheelIndex,2);
								local wheelB = self.spec_wheels.wheels[i];
								if wheelB == nil then return; end;
								local nodeA = wheelA.driveNode; if nodeA == nil then node = wheelA.repr; end;
								local nodeB = wheelB.driveNode; if nodeB == nil then node = wheelB.repr; end;
								local xA,yA,zA = getWorldTranslation(nodeA);
								local xB,yB,zB = getWorldTranslation(nodeB);
								local gYA = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, xA,yA,zA);
								local gYB = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, xB,yB,zB);
								local difA = yA-gYA; if difA < 0.025 then difA = 0; end;
								local difB = yB-gYB; if difB < 0.025 then difB = 0; end;
								if difA > difB then
									direction = -1;
								elseif difA <=0 and difB <=0 then
									force = 0;
								end;
							end;
						end;
						if rollOver.currentForce > 0 and (rollOver.lastDirection ~= direction and rollOver.lastDirection ~= 0) then
							preventWobble = true;
						else
							rollOver.lastDirection = direction;
						end;
						if not isAlreadyLevel and not preventWobble then
							if force > 0 and rollOver.currentForce < force then 
								rollOver.currentForce = rollOver.currentForce+(force*(dt*0.001));
								force = rollOver.currentForce;
							elseif force <=0 and rollOver.currentForce > 0 then
								rollOver.currentForce = 0;
							end;
							addForce(node,dirX*force,dirY*force,dirZ*force,self.rollOver.rightOffset*direction,self.rollOver.heightOffset,self.rollOver.lengthOffset,true);
							if attachments > 0 then
								for _,attachment in pairs(self.spec_attacherJoints.attachedImplements) do
									attachment = attachment.object;
									if attachment.spec_wheels ~= nil and #attachment.spec_wheels.wheels > 0 then
										local aForce = (7*attachment:getTotalMass(true)/baseForce);
										aForce = force*aForce;
										local nodeB = attachment.components[1].node;
										local dirXB,dirYB,dirZB = localDirectionToWorld(nodeB,0,1,0);
										addForce(nodeB,dirXB*aForce,dirYB*aForce,dirZB*aForce,attachment.rollOver.rightOffset*direction,attachment.rollOver.heightOffset,attachment.rollOver.lengthOffset,true);
									end;
								end;
							end;
						else							
							setAngularVelocity(self.rootNode, 0.0, 0.0, 0.0);
							--setLinearVelocity(self.rootNode, 0.0, 0.0, 0.0);		
							local renderString = rollOver.renderText;
							local uiScale = g_gameSettings:getValue("uiScale");
							local textSize = 0.03*uiScale;
							local oX = textSize * HUDTextDisplay.SHADOW_OFFSET_FACTOR;
							setTextBold(false);
							setTextColor(0,0,0,1);
							setTextAlignment(RenderText.ALIGN_CENTER);
							renderText(0.5+oX,0.05-oX,textSize,renderString);
							------------------------------------------------------------------------------
							setTextColor(0,0.5,1,1);
							renderText(0.5,0.05,textSize,renderString);
						end;
					end;
				end;
			elseif rollOver.currentForce ~= 0 then				
				if not Input.isKeyPressed(Input.KEY_f9) then
					rollOver.currentForce = 0;
					rollOver.lastDirection = 0;
				end;
			end;	
		end;	
	end;		
end;



function rollOver:onLeave()
	if rollOver.currentForce ~= 0 then			
		if not Input.isKeyPressed(Input.KEY_f9) then
			rollOver.currentForce = 0;
			rollOver.lastDirection = 0;
		end;
	end;
end;