﻿----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design."---------------
----------------------------------------------------------------------------

source(Utils.getFilename("rollOver.lua", g_currentModDirectory));

rollOverRegister = {};
rollOverRegister.modDirectory = g_currentModDirectory;

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
rollOverRegister.version = getXMLString(modDesc, "modDesc.version");

function installSpec()
	if g_specializationManager:getSpecializationByName("rollOver") == nil then
		if rollOver == nil then 
			print("ERROR: unable to find source file 'rollOver'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;
					local isAnimated = false;
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "washable" then 
							isWashable = true;
						elseif name == "animatedVehicle" then 
							isAnimated = true;
						end;
					end;
					if isWashable and isAnimated then
						typeDef.specializationsByName["rollOver"] = rollOver;
						table.insert(typeDef.specializationNames, "rollOver");
						table.insert(typeDef.specializations, rollOver);
					end;
				end;
			end;
		end;	
	end;
end;

VehicleTypeManager.validateVehicleTypes = Utils.prependedFunction(VehicleTypeManager.validateVehicleTypes, installSpec);